//+------------------------------------------------------------------+
//|                                                         MA96.mq5 |
//|                        Copyright 2009, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//|                                                         MA16.mq5 |
//|                        Copyright 2009, MetaQuotes Software Corp. |
//|                                              http://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "2009, MetaQuotes Software Corp."
#property link      "http://www.mql5.com"
#property version   "1.00"
#define iNum 16

#property indicator_chart_window
#property indicator_buffers iNum
#property indicator_plots   iNum
//---- plot MA
#property indicator_type1   DRAW_LINE
#property indicator_type2   DRAW_LINE
#property indicator_type3   DRAW_LINE
#property indicator_type4   DRAW_LINE
#property indicator_type5   DRAW_LINE
#property indicator_type6   DRAW_LINE
#property indicator_type7   DRAW_LINE
#property indicator_type8   DRAW_LINE
#property indicator_type9   DRAW_LINE
#property indicator_type10  DRAW_LINE
#property indicator_type11  DRAW_LINE
#property indicator_type12  DRAW_LINE
#property indicator_type13  DRAW_LINE
#property indicator_type14  DRAW_LINE
#property indicator_type15  DRAW_LINE
#property indicator_type16  DRAW_LINE

#property  indicator_color1  Red
#property  indicator_color2  OrangeRed //DarkOrange
#property  indicator_color3  Gold
#property  indicator_color4  Yellow
#property  indicator_color5  Lime
#property  indicator_color6  Aqua
#property  indicator_color7  Blue
#property  indicator_color8  Magenta
#property  indicator_color9  Red
#property  indicator_color10  OrangeRed
#property  indicator_color11  Gold
#property  indicator_color12  Yellow
#property  indicator_color13  Lime
#property  indicator_color14  Aqua
#property  indicator_color15  Blue
#property  indicator_color16  Magenta

#property indicator_style1  STYLE_SOLID
#property indicator_style2  STYLE_SOLID
#property indicator_style3  STYLE_SOLID
#property indicator_style4  STYLE_SOLID
#property indicator_style5  STYLE_SOLID
#property indicator_style6  STYLE_SOLID
#property indicator_style7  STYLE_SOLID
#property indicator_style8  STYLE_SOLID
#property indicator_style9  STYLE_DASHDOT
#property indicator_style10 STYLE_DASHDOT
#property indicator_style11 STYLE_DASHDOT
#property indicator_style12 STYLE_DASHDOT
#property indicator_style13 STYLE_DASHDOT
#property indicator_style14 STYLE_DASHDOT
#property indicator_style15 STYLE_DASHDOT
#property indicator_style16 STYLE_DASHDOT

#property indicator_label1  "MA1"
#property indicator_width1  1

//--- input parameters
input bool               AsSeries=true;
input ENUM_MA_METHOD     smootMode=MODE_EMA;
input ENUM_APPLIED_PRICE price=PRICE_CLOSE;
input int                shift=0;
//---- indicator parameters]
int Param[iNum];
//--- indicator buffers
class CIndicatorBuffer
{
public:
   int mhandle;
   double mbuffer[];
bool  mArraySetAsSeries(bool set)
{return ArraySetAsSeries(mbuffer, set);}
bool  mSetIndexBuffer(int index, ENUM_INDEXBUFFER_TYPE data_type)
{return SetIndexBuffer(index, mbuffer, data_type);}
bool  mPlotIndexSetInteger(int plot_index, ENUM_PLOT_PROPERTY_INTEGER prop_id, int prop_value)
{return PlotIndexSetInteger(plot_index, prop_id, prop_value);}
bool  mPlotIndexSetString(int plot_index, ENUM_PLOT_PROPERTY_STRING prop_id, string prop_value)
{return PlotIndexSetString(plot_index, prop_id, prop_value);}
int  mCopyBuffer(int count)
{return CopyBuffer(mhandle, 0, 0, count, mbuffer);}
};
CIndicatorBuffer MAA[iNum];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int OnInit()
  {
//--- indicator buffers mapping
   if(AsSeries) {
      for(int i=0; i<iNum; i++)
         MAA[i].mArraySetAsSeries(true);
   }

   IndicatorSetString(INDICATOR_SHORTNAME,"MA16(N*10)"+IntegerToString(AsSeries));
//---
   for(int i=0; i<iNum; i++)
   {
      Param[i]=10*(i+1);
      MAA[i].mSetIndexBuffer(i,INDICATOR_DATA);
      MAA[i].mPlotIndexSetInteger(i,PLOT_DRAW_TYPE,DRAW_LINE);
      MAA[i].mPlotIndexSetString(i,PLOT_LABEL,"MA"+IntegerToString(i,2,'0'));
      MAA[i].mhandle=iMA(Symbol(),0,Param[i],shift,smootMode,price);
   }
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int OnCalculate(const int rates_total,
                const int prev_calculated,
                const datetime &time[],
                const double &open[],
                const double &high[],
                const double &low[],
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[])
  {
//--- Copy the values of the moving average in the buffer MABuffer
   int copied;
   for(int i=0; i<iNum; i++)
      copied=MAA[i].mCopyBuffer(rates_total);
 //--- return value of prev_calculated for next call
   return(rates_total);
  }
//+------------------------------------------------------------------+
